=== debian/changelog ===
scalasca (1.4.3-1) unstable; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 06 Apr 2013 16:27:15 +0200

scalasca (1.4.2-1) unstable; urgency=low

  * Initial release (Closes: #691137)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 27 Sep 2012 19:32:09 +0200
