=== debian/control ===
Source: scalasca
Section: devel
Priority: extra
Maintainer: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, mpi-default-dev,
 binutils-dev, gfortran
Standards-Version: 3.9.3
Homepage: http://www.scalasca.org/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/scalasca/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/scalasca/trunk/

Package: scalasca
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scalable performance Analysis of Large-Scale parallel Applications
 Tool that supports the performance optimization of parallel programs by
 measuring and analyzing their runtime behavior. The analysis identifies
 potential performance bottlenecks - in particular those concerning
 communication and synchronization - and offers guidance in exploring their
 causes.


Package: scalasca-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scalable performance Analysis of Large-Scale parallel Applications
 Tool that supports the performance optimization of parallel programs by
 measuring and analyzing their runtime behavior. The analysis identifies
 potential performance bottlenecks - in particular those concerning
 communication and synchronization - and offers guidance in exploring their
 causes.
 .
 This package contains examples.
