=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@


override_dh_auto_configure:
	./configure --prefix=$(CURDIR)/debian/tmp/usr/ --disable-zlib --compiler=gnu --mpi=openmpi

override_dh_auto_build:
	make OPTCFLAGS="$$(dpkg-buildflags --get CFLAGS)" OPTCXXXFLAGS="-OX `dpkg-buildflags --get CXXFLAGS`" OPTFFLAGS="`dpkg-buildflags --get FFLAGS`" OPTLDFLAGS="`dpkg-buildflags --get LDFLAGS`" 

override_dh_clean:
	rm -rf build-*
	dh_clean
