=== debian/watch ===
version=3
http://www.scalasca.org/download/scalasca/scalasca.html \
.*/scalasca-(.*)\.tar\.gz  debian debian/orig-tar.sh
