## scalasca 2.0

=== debian/changelog ===
scalasca (2.0-2) unstable; urgency=low

  * Conflicts with nmh because of the same manpage (Closes: #722931)
  * Standards-Version updated to 3.9.5

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 11 Dec 2013 16:52:06 +0100

scalasca (2.0-1) unstable; urgency=low

  * New upstream release (Closes
  * Make scalasca conflicts with dvb-apps which conflicts on /usr/bin/scan
    (Closes: #704809)
  * scalasca-examples removed
  * hardening flags added
  * manpages added
  * Standards-Version updated to 3.9.4
  * Switch to compat mode 9
  * Fix some typo in the copyright file

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 28 Aug 2013 10:16:40 +0200
