=== debian/control ===
Source: scalasca
Section: devel
Priority: extra
Maintainer: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 9.0.0), dpkg-dev (>= 1.16.1~), autotools-dev,
 mpi-default-dev, binutils-dev, gfortran, help2man
Standards-Version: 3.9.5
Homepage: http://www.scalasca.org/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/scalasca/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/scalasca/trunk/

Package: scalasca
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Conflicts: dvb-apps, nmh
Description: Scalable performance Analysis of Large-Scale parallel Applications
 Tool that supports the performance optimization of parallel programs by
 measuring and analyzing their runtime behavior. The analysis identifies
 potential performance bottlenecks - in particular those concerning
 communication and synchronization - and offers guidance in exploring their
 causes.
