=== debian/watch ===
version=3
http://www.scalasca.org/software/scalasca-2.x/download.html \
.*/scalasca-(.*)\.tar\.gz  debian debian/orig-tar.sh
